// car.cpp
// ----------------------------------------------------------------------
//
// CSE 143
// Homework 4
// http://www.cs.washington.edu/education/courses/143/00su/homework/
// 21 Jul 2000, Ken Yasuhara


#include <iostream.h>
#include <assert.h>
#include "car.h"


// initialize class static member
// Don't worry if you don't understand this.
int Car::instanceCount = 0;


Car::Car(const int newArrivalTime, const int newPassengerCount) 
{
  assert(newArrivalTime >= 0);
  assert(newPassengerCount >= 0 && 
         newPassengerCount <= MAX_PASSENGERS_PER_CAR);

  arrivalTime = newArrivalTime;
  passengerCount = newPassengerCount;
  ticketed = false;
  boarded = false;

  instanceID = Car::instanceCount;
  Car::instanceCount++;
}


void
Car::issueTicket() 
{
  assert(!isTicketed());
  ticketed = true;
}


void
Car::board() 
{
  assert(isTicketed() && !isBoarded());
  boarded = true;
}


void
Car::print() const
{
  cout << "car" << getInstanceID() << " (" 
       << getArrivalTime() << ", " 
       << getPassengerCount() << ")" << endl;
}